import { Balance, NearestEndpoint, OracleData, Ownership, Token } from "./types.js";
export declare function rawGraphQLQuery(query: string, endpoint: string): Promise<any>;
export declare function getNearestEndpoints(endpoint: string): Promise<NearestEndpoint[]>;
export declare function getTransactionIndex(address: string | Uint8Array, endpoint: string): Promise<number>;
export declare function getStorageNoncePublicKey(endpoint: string): Promise<string>;
export declare function getTransactionOwnerships(address: string | Uint8Array, endpoint: string, last?: boolean): Promise<Ownership[]>;
export declare function getToken(tokenAddress: string | Uint8Array, endpoint: string): Promise<{} | Token>;
export declare function getOracleData(endpoint: string, timestamp?: undefined | number): Promise<OracleData>;
export declare function subscribeToOracleUpdates(endpoint: string, handler: Function): Promise<any>;
export declare function getBalance(address: string | Uint8Array, endpoint: string): Promise<Balance>;
export declare function getContractCode(address: string | Uint8Array, endpoint: string): Promise<string>;
