import TransportWebSocket from "isomorphic-ws";
import { AWCStreamChannelState } from "./wallet_rpc.js";
export class AWCWebsocketStreamChannel {
    url;
    websocket = null;
    constructor(url) {
        this.url = url;
    }
    async connect() {
        console.log('WS:// connect');
        this.websocket = new TransportWebSocket(this.url);
        this.websocket.onopen = this._onReady === null ?
            null :
            (_) => {
                this._onReady();
            };
        this.websocket.onmessage =
            this._onReceive === null ?
                null :
                (event) => {
                    this._onReceive(event.data.toString());
                };
        this.websocket.onclose = this._onClose === null ?
            null :
            (event) => {
                this.websocket = null;
                this._onClose(event.reason);
            };
    }
    async close() {
        this.websocket?.close();
        this.websocket = null;
    }
    async send(data) {
        await this.websocket.send(data);
    }
    _onReceive = null;
    get onReceive() { return this._onReceive; }
    ;
    set onReceive(onReceive) {
        this._onReceive = onReceive;
    }
    _onReady = null;
    get onReady() { return this._onReady; }
    ;
    set onReady(onReady) {
        this._onReady = onReady;
    }
    _onClose = null;
    get onClose() { return this._onClose; }
    ;
    set onClose(onClose) {
        this._onClose = onClose;
    }
    get state() {
        switch (this.websocket?.readyState) {
            case TransportWebSocket.CONNECTING: return AWCStreamChannelState.CONNECTING;
            case TransportWebSocket.OPEN: return AWCStreamChannelState.OPEN;
            case TransportWebSocket.CLOSING: return AWCStreamChannelState.CLOSING;
            default: return AWCStreamChannelState.CLOSED;
        }
    }
}
//# sourceMappingURL=wallet_rpc.websocket.js.map