import { ArchethicWalletClient } from "./api/wallet_rpc.js";
export interface Endpoint {
    get isRpcAvailable(): boolean;
    get origin(): string;
    get nodeEndpoint(): URL | null;
}
export declare class EndpointFactory {
    build(endpoint: string | undefined): Endpoint;
}
export declare class DirectEndpoint implements Endpoint {
    origin: string;
    nodeEndpoint: URL;
    get isRpcAvailable(): boolean;
    constructor(endpoint: string);
}
export declare class AWCEndpoint implements Endpoint {
    readonly rpcClient: ArchethicWalletClient;
    readonly origin: string;
    private _nodeEndpoint;
    get isRpcAvailable(): boolean;
    constructor(client: ArchethicWalletClient);
    get nodeEndpoint(): URL | null;
    resolve(): Promise<void>;
}
