import Account, { Keychain } from "./account.js";
import { NodeRPCClient } from "./api/node_rpc.js";
import { ConnectionState } from "./api/types.js";
import { AWCStreamChannel, AWCStreamChannelState, ArchethicWalletClient } from "./api/wallet_rpc.js";
import * as Crypto from "./crypto.js";
import { Endpoint } from "./endpoint.js";
import Network from "./network.js";
import Transaction from "./transaction.js";
import * as Contract from "./contract.js";
import * as Utils from "./utils.js";
export { AWCStreamChannel, AWCStreamChannelState, ArchethicWalletClient, ConnectionState, Crypto, Keychain, Utils, Contract };
export default class Archethic {
    endpoint: Endpoint;
    rpcWallet: ArchethicWalletClient | undefined;
    rpcNode: NodeRPCClient | undefined;
    transaction: Transaction;
    nearestEndpoints: Set<string>;
    account: Account;
    network: Network;
    constructor(endpoint: string | undefined);
    connect(): Promise<this>;
    requestNode(call: (endpoint: string) => Promise<any>): Promise<any>;
}
